# Singularity Python

[![Build Status](https://travis-ci.org/singularityhub/singularity-cli.svg?branch=master)](https://travis-ci.org/singularityhub/singularity-cli)
[![GitHub actions status](https://github.com/singularityhub/singularity-cli/workflows/spython-ci/badge.svg?branch=master)](https://github.com/singularityhub/singularity-cli/actions?query=branch%3Amaster+workflow%3Aspython-ci)

Singularity Python (spython) is the Python API for working with <a href="https://sylabs.io/guides/latest/user-guide/" target="_blank">Singularity</a> containers. See
the [documentation](https://singularityhub.github.io/singularity-cli) for installation and usage, and
the [install instructions](https://singularityhub.github.io/singularity-cli/install) for a quick start.

We provide a [Singularity](Singularity) recipe for you to use if more convenient, along with the [full modules docstring](https://singularityhub.github.io/singularity-cli/api/source/spython.main.base.html#module-spython.main.base).

As of version 0.1.0, we only support Singularity > 3.5.2. This is done to encourage using
newer versions of Singularity with security fixes. If you want to use an older version of Singularity,
you will need to use version 0.0.85 or earlier.

## 😁️ Contributors 😁️

We use the [all-contributors](https://github.com/all-contributors/all-contributors) 
tool to generate a contributors graphic below.

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->
<table>
  <tr>
    <td align="center"><a href="https://github.com/Flamefire"><img src="https://avatars.githubusercontent.com/u/309017?v=4?s=100" width="100px;" alt=""/><br /><sub><b>Flamefire</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=Flamefire" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/kinow"><img src="https://avatars.githubusercontent.com/u/304786?v=4?s=100" width="100px;" alt=""/><br /><sub><b>kinow</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=kinow" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/tschoonj"><img src="https://avatars.githubusercontent.com/u/65736?v=4?s=100" width="100px;" alt=""/><br /><sub><b>tschoonj</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=tschoonj" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/al3x609"><img src="https://avatars.githubusercontent.com/u/4086644?v=4?s=100" width="100px;" alt=""/><br /><sub><b>al3x609</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=al3x609" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/mobiusklein"><img src="https://avatars.githubusercontent.com/u/1426041?v=4?s=100" width="100px;" alt=""/><br /><sub><b>mobiusklein</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=mobiusklein" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/MarDiehl"><img src="https://avatars.githubusercontent.com/u/6196733?v=4?s=100" width="100px;" alt=""/><br /><sub><b>MarDiehl</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=MarDiehl" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/shnizzedy"><img src="https://avatars.githubusercontent.com/u/5974438?v=4?s=100" width="100px;" alt=""/><br /><sub><b>shnizzedy</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=shnizzedy" title="Code">💻</a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/wkpalan"><img src="https://avatars.githubusercontent.com/u/6353590?v=4?s=100" width="100px;" alt=""/><br /><sub><b>wkpalan</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=wkpalan" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/cceyda"><img src="https://avatars.githubusercontent.com/u/15624271?v=4?s=100" width="100px;" alt=""/><br /><sub><b>cceyda</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=cceyda" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/neumann-nico"><img src="https://avatars.githubusercontent.com/u/33637944?v=4?s=100" width="100px;" alt=""/><br /><sub><b>neumann-nico</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=neumann-nico" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/vsoch"><img src="https://avatars.githubusercontent.com/u/814322?v=4?s=100" width="100px;" alt=""/><br /><sub><b>vsoch</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=vsoch" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/pierlauro"><img src="https://avatars.githubusercontent.com/u/6776431?v=4?s=100" width="100px;" alt=""/><br /><sub><b>pierlauro</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=pierlauro" title="Code">💻</a></td>
    <td align="center"><a href="https://github.com/biosugar0"><img src="https://avatars.githubusercontent.com/u/18737819?v=4?s=100" width="100px;" alt=""/><br /><sub><b>biosugar0</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=biosugar0" title="Code">💻</a></td>
  </tr>
</table>

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->

 

## License

This code is licensed under the MPL 2.0 [LICENSE](LICENSE).

## Help and Contribution

Please contribute to the package, or post feedback and questions as <a href="https://github.com/singularityhub/singularity-cli" target="_blank">issues</a>. For points that require discussion of the larger group, please use the <a href="https://groups.google.com/a/lbl.gov/forum/#!forum/singularity" target="_blank">Singularity List</a>
